;==============================================================
; AY48 r0067 for ZX Spectrum 48 with covox\beeper
; by NS							11.2015
;==============================================================
;   ay48   

ay48mode = 2	; 1 AY48 covox v01 + simple stereo	;424t 8254 Hz
		; 2 AY48 covox v02			;396t 8838 Hz
		; 3 AY48SN covox			;333t 10510 Hz
		; 7 AY48SN beeper v03X2 4x 12extra_nop	;705t 4964 Hz  19858 Hz PWM
		; 8 AY48SN beeper v03X3 1x		;585t 5982 Hz  5982 Hz PWM
		;12 AY48 covox v01 + 24 bit envelope	;408t 8578 Hz
		;13 AY48 24 bit covox			;489t 7157 Hz

ay48startaddr = $5D00

mpinitaddr = $6200		;+0h
mpplayaddr = mpinitaddr + $5	;+5h	 
ayregbuffer = mpinitaddr + $6AE	;+6AEh	Vortex Tracker II v1.0 beta 17

;ayregbuffer = $6bc9	;ts ok
;ayregbuffer = $6c4e	;ts ??????

vortexaymute = 1		;   AY   Vortex Tracker-
				;( ret-)

startpause = 0		;150 255

;============================================================
;  ,   z80    AY-

voltabtype = 1	;1 YM2149F (by DDp)
		;2 WF19054 (by DDp)
		;3 YM2203C (by DDp)
		;4 AY-3-8912A (Microchip) (by DDp)
		;5 AY-3-8912A (GI) (by DDp)
		;6 YM Hacker KAY
		;7 AY Hacker KAY
		;8 Composite YM (by introspec)
		;9 Composite AY (by introspec)

	lua
	z80clc = 3500000	-- z80
	ayclc = 1750000		--  AY
	maxfrqoverflow = 2	-- 0 -  ,     ay48
				--          ay48
				-- 1 -      
				-- 2 -    2\4\8\16   
	endlua

;============================================================
;    

intmodcompensation = 1	;   ,
cmpcicles = 16		;   
			;
			;~15 - 1 AY48 covox v01
			;~16 - 2 AY48 covox v02
			;~19 - 3 AY48SN covox
			; ~9 - 7 AY48SN beeper v03X2 4x 12extra_nop
			;~11 - 8 AY48SN beeper v03X3 1x
			;~16 - 12 AY48 covox v01 + 24 bit envelope
			;~15 - 13 AY48 24 bit covox	
precalccmpcicles = 1	;   

intout0 = 1		;      \  

intvolreset = 0		;

intcntres = 0		;    
			;(50    )
			;   "   "


;============================================================
; 

stereo = 0		;  ,   
stereodiv = 0		;     2
stvoltabdivchng = 1	;       
			;  \  

chngvoltabdiv = 0	;   
			;0 - off
			;768 
			;771 = (65535/85)  85=(255/3)  
			;516 = (65535/127) 127 = (255/2)  stereodiv = 0
			;385 = (65535/170) 170 = (255*(2/3))  stereodiv = 1


;============================================================
;  

usenztab = 1		;1  4x   
			;0      chngnztabhaddr * 100h

chngnztabhaddr = $01	;00-ROM covox 01-ROM beeper 
			;   AF00h,0000h,7800h,A000h,3D00h!!!!
			;   
			;       
nzsampsize = $03	;  
			;03h - nztab  3Fh\1Fh - ROM covox  1Fh - ROM beeper 
			;2x-01h 4x-03h 8x-07h 16x-0Fh 32x-1Fh 64x-3Fh 128x-7Fh 256x-FFh

	lua
	noisefrqdiv = 1	--   (;0.5 1 2...100500)
			--(      
			--    AY48)
	endlua


nzfrqtabtp = 0		;
			;0 -  0 1 
			;1 -  0 1 
			;2 -    396t  (0 1 )


		;!!!!  ay48mode = 8   nzmcr = 1
		;     - 
nzmcr = 3	;1,2,3,4	 \  
		;1\3		     

noizreg = $6C	;6c	;$6C-ld l,h	nzzz (osc7encnt H)
nzrg2 = $6F	;6f	;$6B-ld l,e	nzzz (osc7encnt H)
nzrg3 = $6D	;6d	;$6F-ld l,a	 nz(osc7cmixer)
nzrg4 = $6C		;$6D-ld l,l	  beepnz (osc7encnt L)
			;$00-nop	  beepnz (osc7encnt L)
			;$69-ld l,c	   trm(osc7beepport)
			;$6A-ld l,d	   trm(osc7enshp)  
			;$68-ld l,b	    nzoff (osc7nz 00\ff)
			;

nzmcrcnt = 0


;============================================================
;  

;osc1
osc1cvx2beep = 0	;0 - off
			;1 - overflow
			;2 - 3ch overflow
			;3 - beep2bitDAC

osc1cvx2bpcnfg = 0	;
cvx2bpvoltabdivchng = 1	;
cvx2bpintout0 = 1	;
cvx2bptab1haddr = $40	;


;----------------------------------------------------------------
;osc2
;----------------------------------------------------------------
;osc3
;----------------------------------------------------------------

;osc7	AY48SN beeper v03X2 4x 12extra_nop
osc7lightver = 1		;1
osc7vljptabtp = 1		;
osc7lvljptabtp = 1		;
osc7silentvol = 1		;
osc7pwmnoizgate = 2		;

;----------------------------------------------------------------

;osc8	AY48SN v03X3 1x
osc8vljptabtp = 3		;1 = 1x ; 2 = 2x ; 3 = 3x ; 4 = 4x
osc8vljptabdisplace = 0		; 
osc8vljptabdispsign = 0		;0 = [+]   
				;1 = [-]
osc8silentvol = 1		;
osc8pwmnoizgate = 0		; noise gate- (  -   )


;============================================================
;  

covox = $FB	;251

covox1 = $4F	;79	 
covox2 = $0F	;15

beepport = $FE	;

beep2bitDAC0 = $00	;***0 0blc
beep2bitDAC1 = $09	;***0 1blu
beep2bitDAC2 = $14	;***1 0grn
beep2bitDAC3 = $1F	;***1 1wht

cvx2bp2bitdactab0 = 4	;6
cvx2bp2bitdactab1 = 26	;24
cvx2bp2bitdactab2 = 32	;64


;============================================================
; 

enfrqdvzchk = 1		;   0    
			;    cmpcicles

altregb = $AA		; !!
altrbcbprt = $AAFE	;altregb + beepport
bcffbprt = $FFFE	;FFh??? + beepport?

;    ay48
snzfrq = $7d32
snzcnt = $63e7
senfrq = $1321			;$0000	SN    
sencnt = $6e7d			;$0000      -  
senshp = en01239_D000_8C
schafrq = $37d1
schacnt = $3276
schbfrq = $5e73
schbcnt = $137d
schcfrq = $8321
schccnt = $e76e

smxe = $AF	; 	AFh - xor a
smxhl = $AFAF	; 

;============================================================
;============================================================



;      AY
ayreg0chafrq = ayregbuffer + 0
;ayreg1chafrq
ayreg2chbfrq = ayregbuffer + 2
;ayreg3chbfrq
ayreg4chcfrq = ayregbuffer + 4
;ayreg5chcfrq

ayreg6nzfrq = ayregbuffer + 6

ayreg7mixer = ayregbuffer + 7

ayreg8vola = ayregbuffer + 8
ayreg9volb = ayregbuffer + 9
ayreg10volc = ayregbuffer + 10

ayreg11enfrq = ayregbuffer + 11
;ayreg12enfrq
ayreg13enshp = ayregbuffer + 13



;============================================================

;     
	macro enresetcheckmacro

		;ld a,(ayreg13enshp)
		cp $FF
		jp z,ennotreset

	endm

;============================================================

; 
wnoiza = noiza		;noiza
wena = ena		;ena
wnoizb = noizb		;noizb
wenb = enb		;enb
wnoizc = noizc		;noizc
wenc = enc		;enc

wchafrq = chafrq	;chafrq
wchacnt = chacnt	;chacnt
wchbfrq = chbfrq	;chbfrq
wchbcnt = chbcnt	;chbcnt
wchcfrq = chcfrq	;chcfrq
wchccnt = chccnt	;chccnt

wcha3frq = cha3frq	;chafrq
wcha3cnt = cha3cnt	;chacnt
wchb3frq = chb3frq	;chbfrq
wchb3cnt = chb3cnt	;chbcnt
wchc3frq = chc3frq	;chcfrq
wchc3cnt = chc3cnt	;chccnt

wenfrq = enfrq		;enfrq
wencnt = encnt		;encnt
wenshp = enshp		;enshp

wen3frq = en3frq	;enfrq
wen3cnt = en3cnt	;encnt

wnztab = nztab		;nztab
wnzfrq = nzfrq		;nzfrq

;============================================================

;      
useen01239_D000_8C = 1	;0;1
useen4567F_U000_8C = 1	;0;1
useen8_DDDD_1C = 1	;1;1
useenA_DUDU_2C = 1	;1;1
useenB_D111_8C = 1	;0;1
useenC_UUUU_1C = 1	;0;1
useenD_U111_8C = 1	;0;1
useenE_UDUD_2C = 1	;0;1

;   
chngen01239_D000_8C = en8_DDDD_1C	;en8_DDDD_1C
chngen4567F_U000_8C = en8_DDDD_1C	;en8_DDDD_1C
chngen8_DDDD_1C = en8_DDDD_1C		;en8_DDDD_1C
chngenA_DUDU_2C = enA_DUDU_2C		;enA_DUDU_2C
chngenB_D111_8C = en8_DDDD_1C		;en8_DDDD_1C
chngenC_UUUU_1C = en8_DDDD_1C		;en8_DDDD_1C
chngenD_U111_8C = en8_DDDD_1C		;en8_DDDD_1C
chngenE_UDUD_2C = enA_DUDU_2C		;enA_DUDU_2C

		;en01239_D000_8C
		;en4567F_U000_8C
		;en8_DDDD_1C
		;enA_DUDU_2C
		;enB_D111_8C
		;enC_UUUU_1C
		;enD_U111_8C
		;enE_UDUD_2C

;============================================================

;  
mxanop = $00		;$00;nop
mxadeca = $3D		;$3D;dec a
mxaandb = $A0		;$A0;and b
mxaldab = $78		;$78;ld a,b
mxaxora = $AF		;$AF;xor a
mxaddnop = $00		;$00;DD NOP
mxaldixha = $67		;$67;ld ixh,a

mxbnop = $00		;$00;nop
mxbdeca = $3D		;$3D;dec a
mxbandb = $A0		;$A0;and b
mxbldab = $78		;$78;ld a,b
mxbxora = $AF		;$AF;xor a
mxbddnop = $00		;$00;DD NOP
mxbldixla = $6F		;$67;ld ixl,a

mxcnop = $00		;$00;nop
mxcdeca = $3D		;$3D;dec a
mxcandb = $A0		;$A0;and b
mxcldab = $78		;$78;ld a,b
mxcxora = $AF		;$AF;xor a
mxcfdnop = $00		;$00;FD NOP
mxcldiyha = $67		;$67;ld iyh,a

;============================================================
	if ay48mode = 7
;----------------------------------------------------------------
	if nzmcr = 1
	macro noizregmacro
		defb noizreg
	endm
	endif
;----------------------------------------------------------------
	if nzmcr = 2
	macro noizregmacro
		if nzmcrcnt % 2 = 0
			defb noizreg
		endif
		if nzmcrcnt % 2 = 1
			defb nzrg2
		endif
	endm
	endif
;----------------------------------------------------------------
	if nzmcr = 3
	macro noizregmacro
		if nzmcrcnt % 3 = 0
			defb noizreg
		endif
		if nzmcrcnt % 3 = 1
			defb nzrg2
		endif
		if nzmcrcnt % 3 = 2
			defb nzrg3
		endif
	endm
	endif
;----------------------------------------------------------------
	if nzmcr = 4
	macro noizregmacro
	if nzmcrcnt % 4 = 0
		defb noizreg
	endif
	if nzmcrcnt % 4 = 1
		defb nzrg2
	endif
	if nzmcrcnt % 4 = 2
		defb nzrg3
	endif
	if nzmcrcnt % 4 = 3
		defb nzrg4
	endif
	endm
	endif
;----------------------------------------------------------------
	endif
;----------------------------------------------------------------
;----------------------------------------------------------------
	if ay48mode = 8
;----------------------------------------------------------------
	macro noizregmacro
		defb noizreg
	endm
;----------------------------------------------------------------
	endif

;============================================================

;1 AY48 covox v01
	if ay48mode = 1
	display "mode 1"

mxwrnoiza = wnoiza
mxwrena = wena+1
mxwrnoizb = wnoizb
mxwrenb = wenb+1
mxwrnoizc = wnoizc
mxwrenc = wenc+1

mxwrchafrq = wchafrq+1
mxwrchacnt = wchacnt+1
mxwrchbfrq = wchbfrq+1
mxwrchbcnt = wchbcnt+1
mxwrchcfrq = wchcfrq+1
mxwrchccnt = wchccnt+1

mxwrenfrq = wenfrq+1
mxwrencnt = wencnt+1
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 0
mxbeepver = 0		;ld (noizcp+1),a
usevoljptab = 0
	if osc1cvx2beep = 0
dfay48size = $70	;112
	else
dfay48size = $FF	;112
	endif
jpay48kill = 1
usevars = 0
inttype = 1
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 15		;
	endif
	endif

;============================================================

;2 AY48 covox v02
	if ay48mode = 2
	display "mode 2"

mxwrnoiza = wnoiza
mxwrena = wena+1
mxwrnoizb = wnoizb
mxwrenb = wenb+1
mxwrnoizc = wnoizc
mxwrenc = wenc+1

mxwrchafrq = wchafrq+1
mxwrchacnt = wchacnt+1
mxwrchbfrq = wchbfrq+1
mxwrchbcnt = wchbcnt+1
mxwrchcfrq = wchcfrq+1
mxwrchccnt = wchccnt+1

mxwrenfrq = wenfrq+1
mxwrencnt = wencnt+1
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 0
mxbeepver = 0		;ld (noizcp+1),a
usevoljptab = 0
dfay48size = $70	;112
jpay48kill = 1
usevars = 0
inttype = 1
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 16		;
	endif
	endif

;============================================================

;3 AY48SN covox
	if ay48mode = 3
	display "mode 3"

mxwrnoiza = wnoiza
mxwrena = wena+1
mxwrnoizb = wnoizb
mxwrenb = wenb+1
mxwrnoizc = wnoizc
mxwrenc = wenc+1

mxwrchafrq = wchafrq+1
mxwrchacnt = wchacnt+1
mxwrchbfrq = wchbfrq+1
mxwrchbcnt = wchbcnt+1
mxwrchcfrq = wchcfrq+1
mxwrchccnt = wchccnt+1

mxwrenfrq = wenfrq+1
mxwrencnt = wencnt+1
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
;mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 1
mxbeepver = 0		;ld (noizcp+1),a
usevoljptab = 0
dfay48size = $63	;99
jpay48kill = 1
usevars = 0
inttype = 1
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 19		;
	endif
	endif

;============================================================

;4 AY48SN beeper v01 3x
	if ay48mode = 4
	display "mode 4"

mxwrnoiza = wnoiza+1
mxwrena = wena+1
mxwrnoizb = wnoizb+1
mxwrenb = wenb+1
mxwrnoizc = wnoizc+1
mxwrenc = wenc+1

mxwrchafrq = wchafrq
mxwrchacnt = wchacnt
mxwrchbfrq = wchbfrq
mxwrchbcnt = wchbcnt
mxwrchcfrq = wchcfrq
mxwrchccnt = wchccnt

mxwrenfrq = wenfrq
mxwrencnt = wencnt
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
;mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 1
mxbeepver = 1		;ld (noizcp+1),a
usevoljptab = 1
dfay48size = $2000	;
jpay48kill = 0
usevars = 1
inttype = 2
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 1
	endif
	endif

;============================================================

;5 AY48SN beeper v02 4x
	if ay48mode = 5
	display "mode 5"

mxwrnoiza = wnoiza+1
mxwrena = wena+1
mxwrnoizb = wnoizb+1
mxwrenb = wenb+1
mxwrnoizc = wnoizc+1
mxwrenc = wenc+1

mxwrchafrq = wchafrq
mxwrchacnt = wchacnt
mxwrchbfrq = wchbfrq
mxwrchbcnt = wchbcnt
mxwrchcfrq = wchcfrq
mxwrchccnt = wchccnt

mxwrenfrq = wenfrq
mxwrencnt = wencnt
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
;mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 1
mxbeepver = 1		;ld (noizcp+1),a
usevoljptab = 1
dfay48size = $2000	;
jpay48kill = 0
usevars = 1
inttype = 2
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 1
	endif
	endif

;============================================================

; 6 AY48SN beeper v03X1 6x
	if ay48mode = 6
	display "mode 6"
	display "error AY48SN beeper v03X1 6x does not exist yet!"
	endif

;============================================================

; 7 AY48SN beeper v03X2 4x 12extra_nop
	if ay48mode = 7
	display "mode 7"

mxwrnoiza = wnoiza+1
mxwrena = wena+1
mxwrnoizb = wnoizb+1
mxwrenb = wenb+1
mxwrnoizc = wnoizc+1
mxwrenc = wenc+1

mxwrchafrq = wchafrq
mxwrchacnt = wchacnt
mxwrchbfrq = wchbfrq
mxwrchbcnt = wchbcnt
mxwrchcfrq = wchcfrq
mxwrchccnt = wchccnt

mxwrenfrq = wenfrq
mxwrencnt = wencnt
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
;mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 1
mxbeepver = 1		;ld (noizcp+1),a
usevoljptab = 1
	if osc7lightver = 0
dfay48size = $5D20	;
	display "!!!    !!!   .     4000h )))"
	endif
	if osc7lightver = 1
dfay48size = $3007	;
	endif
jpay48kill = 0
usevars = 1
inttype = 2
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 9		;
	endif
	endif

;============================================================

; 8 AY48SN beeper v03X3 1x
	if ay48mode = 8
	display "mode 8"

mxwrnoiza = wnoiza+1
mxwrena = wena+1
mxwrnoizb = wnoizb+1
mxwrenb = wenb+1
mxwrnoizc = wnoizc+1
mxwrenc = wenc+1

mxwrchafrq = wchafrq
mxwrchacnt = wchacnt
mxwrchbfrq = wchbfrq
mxwrchbcnt = wchbcnt
mxwrchcfrq = wchcfrq
mxwrchccnt = wchccnt

mxwrenfrq = wenfrq
mxwrencnt = wencnt
mxwrenshp = wenshp+1

mxwrnztab = wnztab+1
;mxwrnzfrq = wnzfrq+1

useentntabz = 1
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2bphaddr = $DB	;db00-dcff en 0000-00ff	2x
enh2bphaddr = $D9	;d900-eaff en 00**-ff**	2x hentab

entn2bplasthaddr = $D9

ay48sn = 1
mxbeepver = 1		;ld (noizcp+1),a
usevoljptab = 1
dfay48size = $1A74	;6772
jpay48kill = 0
usevars = 1
inttype = 2
ayregsdecodertype = 1

	if precalccmpcicles = 1
cmpcicles = 11
	endif
	endif

;============================================================

; 9 AY48S covox
	if ay48mode = 9
	display "mode 9"
	display "error AY48S covox does not exist yet!"
	endif

;============================================================

;10 AY48S beeper
	if ay48mode = 10
	display "mode 10"
	display "error AY48S beeper does not exist yet!"
	endif

;============================================================

;11 AY48 oldx beeper
	if ay48mode = 11
	display "mode 11"
	endif

;============================================================

;12 AY48 covox v01 lfo
	if ay48mode = 12
	display "mode 12"

mxwrnoiza = wnoiza
mxwrena = wena+1
mxwrnoizb = wnoizb
mxwrenb = wenb+1
mxwrnoizc = wnoizc
mxwrenc = wenc+1

mxwrchafrq = wchafrq+1
mxwrchacnt = wchacnt+1
mxwrchbfrq = wchbfrq+1
mxwrchbcnt = wchbcnt+1
mxwrchcfrq = wchcfrq+1
mxwrchccnt = wchccnt+1

mxwrenfrq = wenfrq+1
mxwrencnt = wencnt+1
mxwrenshp = wenshp+1

mxwren3frq = wen3frq+1
mxwren3cnt = wen3cnt+1

mxwrnztab = wnztab+1
mxwrnzfrq = wnzfrq+1

useentntabz = 2
tn2bptabhaddr = $DD	;dd00-fcff	32x
en2osc12LFOhaddr = $DA	;da00-dcff en 0000-00ff 3x !!!!

entn2bplasthaddr = $DA

ay48sn = 0
mxbeepver = 0		;ld (noizcp+1),a
usevoljptab = 0
	
dfay48size = $FF	;

jpay48kill = 1
usevars = 0
inttype = 1
ayregsdecodertype = 2

	if precalccmpcicles = 1
cmpcicles = 16		;
	endif
	endif

;============================================================

;13 AY48 24bit covox
	if ay48mode = 13
	display "mode 13"

mxwrnoiza = wnoiza
mxwrena = wena+1
mxwrnoizb = wnoizb
mxwrenb = wenb+1
mxwrnoizc = wnoizc
mxwrenc = wenc+1

mxwrchafrq = wchafrq+1
mxwrchacnt = wchacnt+1
mxwrchbfrq = wchbfrq+1
mxwrchbcnt = wchbcnt+1
mxwrchcfrq = wchcfrq+1
mxwrchccnt = wchccnt+1

mxwrcha3frq = wcha3frq+1
mxwrcha3cnt = wcha3cnt+1
mxwrchb3frq = wchb3frq+1
mxwrchb3cnt = wchb3cnt+1
mxwrchc3frq = wchc3frq+1
mxwrchc3cnt = wchc3cnt+1

mxwrenfrq = wenfrq+1
mxwrencnt = wencnt+1
mxwrenshp = wenshp+1

mxwren3frq = wen3frq+1
mxwren3cnt = wen3cnt+1

mxwrnztab = wnztab+1
mxwrnzfrq = wnzfrq+1

useentntabz = 3
tn2bp24tabhaddr = $CD
entn2bplasthaddr = $CD

ay48sn = 0
mxbeepver = 0		;ld (noizcp+1),a
usevoljptab = 0
	
dfay48size = $FF	;112

jpay48kill = 1
usevars = 0
inttype = 1
ayregsdecodertype = 3

	if precalccmpcicles = 1
cmpcicles = 15		;
	endif
	endif

;============================================================

;14 AY48SNX2 beeper 3ch 3vol
	if ay48mode = 14
	display "mode 14"
	display "error AY48SNX2 beeper 3ch 3vol does not exist yet!"
	endif
;============================================================

;============================================================
;   label not found ,   
	if ay48sn = 1
	display "simple noise"
nzfrq = $4000
	endif	
	if useentntabz = 1
cha3frq = $4002
cha3cnt = $4004
chb3frq = $4006
chb3cnt = $4008
chc3frq = $400a
chc3cnt = $400c
en3frq = $400e
en3cnt = $4010
	endif
	if useentntabz = 2
cha3frq = $4002
cha3cnt = $4004
chb3frq = $4006
chb3cnt = $4008
chc3frq = $400a
chc3cnt = $400c
	endif

;========================

	if osc1cvx2beep = 0
cvx2bpintout0 = 0
	endif
;	if osc2cvx2beep = 0
;cvx2bpintout0 = 0
;	endif
;	if osc3cvx2beep = 0
;cvx2bpintout0 = 0
;	endif

;========================

;========================

;===============================================================
; 
;===============================================================

chvoltabhaddr = $FD	;1x	16   + INTJP!!!!

;============================================================
;FC00-XXXX
;entn2bpfrqtabz
;============================================================

	if ay48sn = 0	;1x
noizfrqtabsize = $01
	else
noizfrqtabsize = $00
	endif
noizfrqtabhaddr = entn2bplasthaddr- noizfrqtabsize

;============================================================

	if usevoljptab = 0	;2x
voljptabsize = $00
	else
voljptabsize = $02
	endif

voljptabhaddr = entn2bplasthaddr - noizfrqtabsize - voljptabsize

;============================================================

	if usenztab = 0
nztabsize = $00
nztabhaddr = chngnztabhaddr
	endif

	if usenztab = 1
nztabsize = $04
nztabhaddr = entn2bplasthaddr - noizfrqtabsize - voljptabsize - nztabsize
	endif
	

	if nztabhaddr = $00
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr = $3D
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr = $A0
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr = $78
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr = $AF
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 1 = $00
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 1  = $3D
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 1 = $A0
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 1 = $78
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 1 = $AF
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 2 = $00
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 2 = $3D
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 2 = $A0
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 2 = $78
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 2 = $AF
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 3 = $00
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 3 = $3D
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 3 = $A0
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 3 = $78
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif
	if nztabhaddr + 3 = $AF
	display "ERROR nztabhaddr+0...3 = 00h\3Dh\A0h\78h\AFh"
	endif

;============================================================

	if useenE_UDUD_2C = 0
enE_UDUD_2Csize = $00
enE_UDUD_2C = chngenE_UDUD_2C
	else
enE_UDUD_2Csize = $01
enE_UDUD_2C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize
	endif
;----------------------------------------------------------------
	if useenD_U111_8C = 0
enD_U111_8Csize = $00
enD_U111_8C = chngenD_U111_8C
	else
enD_U111_8Csize = $01
enD_U111_8C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize
	endif
;----------------------------------------------------------------
	if useenC_UUUU_1C = 0
enC_UUUU_1Csize = $00
enC_UUUU_1C = chngenC_UUUU_1C
	else
enC_UUUU_1Csize = $01
enC_UUUU_1C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize
	endif
;----------------------------------------------------------------
	if useenB_D111_8C = 0
enB_D111_8Csize = $00
enB_D111_8C = chngenB_D111_8C
	else
enB_D111_8Csize = $01
enB_D111_8C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize
	endif
;----------------------------------------------------------------
	if useenA_DUDU_2C = 0
enA_DUDU_2Csize = $00
enA_DUDU_2C = chngenA_DUDU_2C
	else
enA_DUDU_2Csize = $01
enA_DUDU_2C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize-enA_DUDU_2Csize
	endif
;----------------------------------------------------------------
	if useen8_DDDD_1C = 0
en8_DDDD_1Csize = $00
en8_DDDD_1C = chngen8_DDDD_1C
	else
en8_DDDD_1Csize = $01
en8_DDDD_1C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize-enA_DUDU_2Csize-en8_DDDD_1Csize
	endif
;----------------------------------------------------------------
	if useen4567F_U000_8C = 0
en4567F_U000_8Csize = $00
en4567F_U000_8C = chngen4567F_U000_8C
	else
en4567F_U000_8Csize = $01
en4567F_U000_8C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize-enA_DUDU_2Csize-en8_DDDD_1Csize-en4567F_U000_8Csize
	endif
;----------------------------------------------------------------
	if useen01239_D000_8C = 0
en01239_D000_8Csize = $00
en01239_D000_8C = chngen01239_D000_8C
	else
en01239_D000_8Csize = $01
en01239_D000_8C = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize-enA_DUDU_2Csize-en8_DDDD_1Csize-en4567F_U000_8Csize-en01239_D000_8Csize
	endif

;============================================================

entabzlasthaddr = entn2bplasthaddr-noizfrqtabsize-voljptabsize-nztabsize-enE_UDUD_2Csize-enD_U111_8Csize-enC_UUUU_1Csize-enB_D111_8Csize-enA_DUDU_2Csize-en8_DDDD_1Csize-en4567F_U000_8Csize-en01239_D000_8Csize
;----------------------------------------------------------------
ay48size = dfay48size		;ay48endaddr - ay48startaddr
ay48addr = (entabzlasthaddr * $100) - ay48size





	if chngvoltabdiv > 0
voltabdiv = chngvoltabdiv
	endif

	if voltabtype = 1
	include "voltab1_YM2149F.asm"
	display "voltab1_YM2149F included"
	endif
	if voltabtype = 2
	include "voltab2_WF19054.asm"
	display "voltab2_WF19054 included"
	endif
	if voltabtype = 3
	include "voltab3_YM2203C.asm"
	display "voltab3_YM2203C included"
	endif
	if voltabtype = 4
	include "voltab4_AY_3_8912A_Microchip.asm"
	display "voltab4_AY_3_8912A_Microchip included"
	endif
	if voltabtype = 5
	include "voltab5_AY_3_8912A_GI.asm"
	display "voltab5_AY_3_8912A_GI included"
	endif
	if voltabtype = 6
	include "voltab6_YM_Hacker_KAY.asm"
	display "voltab6_YM_Hacker_KAY included"
	endif
	if voltabtype = 7
	include "voltab7_AY_Hacker_KAY.asm"
	display "voltab7_AY_Hacker_KAY included"
	endif
	if voltabtype = 8
	include "voltab8_Composite_YM.asm"
	display "voltab8_Composite_YM included"
	endif
	if voltabtype = 9
	include "voltab9_Composite_AY.asm"
	display "voltab9_Composite_AY included"
	endif



	org ay48startaddr

ay48start
	if startpause > 0
		ei
		ld b,startpause
startpauseloop	halt
		djnz startpauseloop
	endif

	di
	call mpinitaddr

        ld a,$FD
        ld bc,$0100
        ld de,$FE01
        ld hl,$FE00
        ld (hl),a
        ldir
        di
        inc a
        ld i,a
	nop
        im 2
	nop

	if vortexaymute = 1
	;org mpinitaddr + $5AB
	;ret
	ld a,$C9	;ret
	ld hl,mpinitaddr + $5AB
	ld (hl),a
	endif

	ei
	jp ay481ststart




intframe


	if inttype = 1
	include "int1_covox.asm"
	endif
	if inttype = 2
	include "int2_beeper.asm"
	endif


ay48int


	if intcntres = 1
		ld hl,$0000
		ld (mxwrchacnt),hl
		ld (mxwrchbcnt),hl
		ld (mxwrchccnt),hl
		ld (mxwrencnt),hl
	endif


	if jpay48kill = 1

;ay48int1
		xor a		;4 jp ay48 MUST DIE!!	
		ld h,a		;4
		ld l,a		;4
		ld (jpay48),a	;13
		ld (jpay48+1),hl;16	41
		ret
	endif

ayregsdecode

	if ayregsdecodertype = 1
		include "ayregsdecoder.asm"
	endif
	if ayregsdecodertype = 2
		include "ayregsdecoder2_4osc12LFO.asm"
	endif
	if ayregsdecodertype = 3
		include "ayregsdecoder3_24bit.asm"
	endif


	if jpay48kill = 1
		jp ay48afterint
	else
		ret
	endif

ay48rnd		defb $17


;======================
;player\data
;======================





	if usevoljptab = 1	
	org voljptabhaddr * $100
		if ay48mode = 7
			if osc7lightver = 0
				if osc7vljptabtp = 1
				include "voljposc7sn3x2tab1.asm"
				endif
			endif
			if osc7lightver = 1
				if osc7lvljptabtp = 1
				include "voljposc7sn3x2ltab1.asm"
				endif
			endif
		endif

		if ay48mode = 8
			if osc8vljptabtp = 1
			include "voljposc8sn3x3tab1.asm"
			endif
			if osc8vljptabtp= 2
			include "voljposc8sn3x3tab2.asm"
			endif
			if osc8vljptabtp= 3
			include "voljposc8sn3x3tab3.asm"
			endif
			if osc8vljptabtp= 4
			include "voljposc8sn3x3tab4.asm"
			endif
		endif
	endif









	org ay48addr

	if ay48mode = 1
		if osc1cvx2beep = 0
		include "osc01_AY48_covox_v01.asm"
		display "osc01_AY48_covox_v01 included"
		else
		include "osc01_AY48_covox_v01_cvx2bp.asm"
		display "osc01_AY48_covox_v01_cvx2bp included"
		endif
	endif


	if ay48mode = 2
	include "osc02_AY48_covox_v02.asm"
	display "osc02_AY48_covox_v02 included"
	endif
	if ay48mode = 3
	include "osc03_AY48SN_covox.asm"
	display "osc03_AY48SN_covox included"
	endif

	if ay48mode = 7
		if osc7lightver = 0
	include "osc07_AY48SN_beeper_v03X2_4x.asm"
	display "osc07_AY48SN_beeper_v03X2_4x included"
		endif
		if osc7lightver = 1
	include "osc07_AY48SN_beeper_v03X2_4x_light.asm"
	display "osc07_AY48SN_beeper_v03X2_4x_light included"
		endif
	endif
	if ay48mode = 8
	include "osc08_AY48SN_beeper_v03X3_1x.asm"
	display "osc08_AY48SN_beeper_v03X3_1x included"
	endif

	if ay48mode = 12
	include "osc12_AY48_covox_v01_24bLFO.asm"
	display "osc12_AY48_covox_v01_24bLFO included"
	endif
	if ay48mode = 13
	include "osc13_AY48_24bit_covox_v01.asm"
	display "osc13_AY48_24bit_covox_v01 included"
	endif


	if usevars = 1
enmixer
ena	ld ixh,a	;8
enb	ld ixl,a	;8
enc	ld iyh,a	;8
	ret		;10
			;34

chafrq		defw schafrq
chacnt		defw schacnt
chbfrq		defw schbfrq
chbcnt		defw schbcnt
chcfrq		defw schcfrq
chccnt		defw schccnt
enfrq		defw senfrq
encnt		defw sencnt
	endif





	if useen01239_D000_8C = 1
	org en01239_D000_8C * $100
	include "ensp01239_D000_8C.asm"
	endif
	if useen4567F_U000_8C = 1
	org en4567F_U000_8C * $100
	include "ensp4567F_U000_8C.asm"
	endif
	if useen8_DDDD_1C = 1
	org en8_DDDD_1C * $100
	include "ensp8_DDDD_1C.asm"
	endif
	if useenA_DUDU_2C = 1
	org enA_DUDU_2C * $100
	include "enspA_DUDU_2C.asm"
	endif
	if useenB_D111_8C = 1
	org enB_D111_8C * $100
	include "enspB_D111_8C.asm"
	endif
	if useenC_UUUU_1C = 1
	org enC_UUUU_1C * $100
	include "enspC_UUUU_1C.asm"
	endif
	if useenD_U111_8C = 1
	org enD_U111_8C * $100
	include "enspD_U111_8C.asm"
	endif
	if useenE_UDUD_2C = 1
	org enE_UDUD_2C * $100
	include "enspE_UDUD_2C.asm"
	endif



	if usenztab = 1
	org nztabhaddr * $100
	include "nzsample4xtab.asm"
	endif


;D200h voljptab
;==============
;



	lua
	ayclcdiv16 = ayclc/16
	ayclcdiv256 = ayclc/256 
	ay48maxfrq = (z80clc/ay48osctime)/2
	maxfrqdiv32k = ay48maxfrq/32768
	endlua

	if ay48sn = 0
;XXXXh	noizfrqtab
	org noizfrqtabhaddr * $100

	if nzfrqtabtp = 0
	include "nzfrqtab0.asm"
	endif

	if nzfrqtabtp = 1
	include "nzfrqtab1.asm"
	endif

	if nzfrqtabtp = 2;
	include "nzfrqtab2.asm"
	endif

	endif

;D400h
;D500h
;DD00h

	if useentntabz = 1
	include "entn2bpfrqtab1.asm"
	endif
	if useentntabz = 2
	include "entn2bpfrqtab2.asm"
	endif
	if useentntabz = 3
	include "entn2bpfrqtab3.asm"
	endif

;FD00h
;chvoltab + intjp
	org chvoltabhaddr * $100
		dup 15
	defb	ayDAC00
	defb	ayDAC01
	defb	ayDAC02
	defb	ayDAC03
	defb	ayDAC04
	defb	ayDAC05
	defb	ayDAC06
	defb	ayDAC07
	defb	ayDAC08
	defb	ayDAC09
	defb	ayDAC10
	defb	ayDAC11
	defb	ayDAC12
	defb	ayDAC13
	defb	ayDAC14
	defb	ayDAC15
		edup

	defb	ayDAC00
	defb	ayDAC01
	defb	ayDAC02
	defb	ayDAC03
	defb	ayDAC04
	defb	ayDAC05
	defb	ayDAC06
	defb	ayDAC07
	defb	ayDAC08
	defb	ayDAC09
	defb	ayDAC10
	defb	ayDAC11
	defb	ayDAC12

	jp intframe

;FE00h	int vector table

;FF00h	stack

